#include <iostream>
#include <vector>
using namespace std;
struct edge {
    int to, revInd, cap, cf;
};
vector < edge > neigh[128];
int n, m, q;
int onInd[128][128];

void addEdge ( int x, int y ) {

    if ( onInd[x][y] == -1 ) {
        onInd[x][y] = neigh[x].size();
        onInd[y][x] = neigh[y].size();
    }else {
        neigh[x][ onInd[x][y] ].cap ++;
        neigh[y][ onInd[y][x] ].cap ++;
        return;
    }

    edge crr;
    crr.to = y;
    crr.revInd = neigh[y].size();
    crr.cap = 1;
    crr.cf = 0;
    neigh[x].push_back( crr );

    crr.to = x;
    crr.revInd = neigh[x].size()-1;

    neigh[y].push_back ( crr );
}

int ansF = 0;
int used[128], usedTst;
int getF ( int x, int cf ) {
    if ( x == n ) { return cf; }
    if ( used[x] == usedTst ) { return 0; }
    used[x] = usedTst;
    //cout << "reached "<< x << "  "<< cf << "\n";

    for ( int i = neigh[x].size()-1 ; i >= 0 ; i -- ) {
        int nf = neigh[x][i].cap - neigh[x][i].cf;
        nf = min( cf, nf );
        if ( nf ) {
            nf = getF ( neigh[x][i].to, nf );
            if ( nf ) {
                int to = neigh[x][i].to, j = neigh[x][i].revInd;

                neigh[x][i].cf += nf;
                neigh[to][j].cf -= nf;
                return nf;
            }
        }
    }
    return 0;
}

int main () {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for ( int i = 0 ; i <= n ; i ++ ) {
        for ( int j = 0 ; j <= n ; j ++ ) {
            onInd[i][j] = -1;
        }
    }

    for ( int i = 0 ; i < m ; i ++ ) {
        int a, b;
        cin >> a >> b;
        addEdge ( a, b );
    }
    while ( 1 ) {
        usedTst ++;
        int cf = getF( 1, (1<<20)) ;
        ansF += cf;
//        cout << "+cf\n";
        if ( cf == 0 ) { break; }
    }
    cout << ansF << "\n";
    cin >> q;
    for ( int i = 0 ; i < q ; i ++ ) {
        int a, b;
        cin >> a >> b;
        addEdge ( a, b );

        if ( used[a] != usedTst && used[b] != usedTst ) {
            cout << ansF << "\n";
            continue;
        }

        while ( 1 ) {
            usedTst ++;
            int cf = getF( 1, (1<<20)) ;
            ansF += cf;
    //        cout << "+cf\n";
            if ( cf == 0 ) { break; }
        }

        cout << ansF << "\n";
    }
    return 0;
}
/*

5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5

*/
