#include <iostream>
#include <vector>
#include <cstdlib>
using namespace std;
struct edge {
    int to, revInd, cap, cf;
};
vector < edge > neigh[128];
int n, m, q;
int onInd[128][128];

void addEdge ( int x, int y ) {

    if ( onInd[x][y] == -1 ) {
        onInd[x][y] = neigh[x].size();
        onInd[y][x] = neigh[y].size();
    }else {
        neigh[x][ onInd[x][y] ].cap ++;
        neigh[y][ onInd[y][x] ].cap ++;
        return;
    }

    edge crr;
    crr.to = y;
    crr.revInd = neigh[y].size();
    crr.cap = 1;
    crr.cf = 0;
    neigh[x].push_back( crr );

    crr.to = x;
    crr.revInd = neigh[x].size()-1;

    neigh[y].push_back ( crr );
}

int ansF = 0;
int used[128], usedTst;

bool getF ( int x ) {
    if ( x == n ) { return 1; }
    if ( used[x] == usedTst ) { return 0; }
    used[x] = usedTst;
    //cout << "reached "<< x << "  "<< cf << "\n";
    for ( int i = 0 ; i < neigh[x].size() ; i ++ ) {
        if ( neigh[x][i].cap > neigh[x][i].cf ) {

            int nf = getF ( neigh[x][i].to );
            if ( nf ) {

                neigh[x][i].cf ++;
                neigh[neigh[x][i].to][neigh[x][i].revInd].cf --;
                return 1;
            }
        }
    }
    return 0;
}

int main () {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for ( int i = 0 ; i <= n ; i ++ ) {
        for ( int j = 0 ; j <= n ; j ++ ) {
            onInd[i][j] = -1;
        }
    }

    for ( int i = 0 ; i < m ; i ++ ) {
        int a, b;
        cin >> a >> b;
        addEdge ( a, b );
    }
    while ( 1 ) {
        usedTst ++;
        int cf = getF( 1 ) ;
        ansF += cf;
//        cout << "+cf\n";
        if ( cf == 0 ) { break; }
    }
    cout << ansF << "\n";
    cin >> q;
    srand( 420420 );

    for ( int i = 0 ; i < q ; i ++ ) {
        short a, b;
        cin >> a >> b;
        addEdge ( a, b );

        int ch = rand()%2;
        //if ( i >= 4000 && i +4000 < q && ch == 0 ) { cout << ansF << "\n"; continue; }

        if ( used[a] != usedTst && used[b] != usedTst ) {
            cout << ansF << "\n";
            continue;
        }

        usedTst ++;
        int cf = getF( 1 ) ;
        ansF += cf;

        cout << ansF << "\n";
    }
    return 0;
}
/*

5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5

*/
