#include <iostream>
#include <vector>
#include <cstdlib>
using namespace std;

struct edge {
    int to, revInd, cap, cf;
};
vector < edge > neigh[128];
vector < edge > neighCop[128];
int ss[128];

int n, m, q;
int ansFCop;
int onInd[128][128];
int bSz = 20;
int aq[(1<<20)], bq[(1<<20)];


void addEdge ( int x, int y ) {



    int fInd = -1, revInd = -1;

    for ( int i = 0 ; i < neigh[x].size() ; i ++ ) { if ( neigh[x][i].to == y ) { fInd = i; break; } }
    for ( int i = 0 ; i < neigh[y].size() ; i ++ ) { if ( neigh[y][i].to == x ) { revInd = i; break; } }

    if ( fInd != -1 ) {
        neigh[x][ fInd ].cap ++;
        neigh[y][ revInd ].cap ++;
        return;
    }

    edge crr;
    crr.to = y;
    crr.revInd = neigh[y].size();
    crr.cap = 1;
    crr.cf = 0;
    neigh[x].push_back( crr );

    crr.to = x;
    crr.revInd = neigh[x].size()-1;

    neigh[y].push_back ( crr );
}

int ansF = 0;
int used[128], usedTst;
int getF ( int x, int cf ) {
    if ( x == n ) { return cf; }
    if ( used[x] == usedTst ) { return 0; }
    used[x] = usedTst;
    //cout << "reached "<< x << "  "<< cf << "\n";

    for ( int i = ss[x] ; i < neigh[x].size() ; i ++ ) {
        ss[x] = i;
        int nf = neigh[x][i].cap - neigh[x][i].cf;
        nf = min( cf, nf );
        if ( nf ) {
            nf = getF ( neigh[x][i].to, nf );
            if ( nf ) {
                int to = neigh[x][i].to, j = neigh[x][i].revInd;

                neigh[x][i].cf += nf;
                neigh[to][j].cf -= nf;
                return nf;
            }
        }
    }
    return 0;
}

bool tryBsz ( int s) {

    for ( int j = s ; j < q && j < s +bSz ; j ++ ) {
        addEdge ( aq[j], bq[j] );
    }

    for ( int i = 0 ; i <= n ; i ++ ) { ss[i] = 0; }

    while ( 1 ) {

        usedTst ++;
        int cff = getF( 1, 1<<20 ) ;
        ansF += cff;
//        cout << "+cf\n";
        if ( cff == 0 ) { break; }
        return 0;
    }
//    cout << ansF << ": " <<  ansFCop << "\n";
    return ansF == ansFCop;
}

void cop ( ){
    ansFCop = ansF;
    for ( int i = 0 ; i <= n ; i ++ ) {
        neighCop[i] = neigh[i];
    }
}
void restore () {
    ansF = ansFCop;
    for ( int i = 0 ; i <= n ; i ++ ) {
        neigh[i] = neighCop[i];
    }
}


int main () {

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for ( int i = 0 ; i <= n ; i ++ ) {
        for ( int j = 0 ; j <= n ; j ++ ) {
            onInd[i][j] = -1;
        }
    }


    for ( int i = 0 ; i < m ; i ++ ) {
        int a, b;
        cin >> a >> b;
        addEdge ( a, b );
    }

    while ( 1 ) {
        for ( int i = 0 ; i <= n ; i ++ ) { ss[i] = 0; }
        usedTst ++;
        int cf = getF( 1, (1<<20) ) ;
        ansF += cf;
//        cout << "+cf\n";
        if ( cf == 0 ) { break; }
    }
    cout << ansF << "\n";
    cin >> q;

    for ( int i = 0 ; i < q ; i ++ ) {
        cin >> aq[i] >> bq[i];
    }

    /*
    for ( int i = 0 ; i < q ; i ++ ) {

        addEdge ( aq[i], bq[i] );

        while ( 1 ) {
            usedTst ++;
            int cff = getF( 1 ) ;
            ansF += cff;
    //        cout << "+cf\n";
            if ( cff == 0 ) { break; }
        }

        cout << ansF << "\n";
    }
    return 0;
    */

    for ( int i = 0 ; i < q ; ) {

        cop();
        if ( tryBsz ( i ) ) {
           // cout << "ok "<< i << ": "<< i+bSz << "\n";
            for ( int j = 0 ; i+j < q && j < bSz ; j ++ ) {
                cout << ansF << "\n";
            }
            i += bSz;
        }else {

            restore();

            for ( int j = i ; j < q && j < i +bSz ; j ++ ) {
                addEdge ( aq[j], bq[j] );

                while ( 1 ) {
                    for ( int i = 0 ; i <= n ; i ++ ) { ss[i] = 0; }
                    usedTst ++;
                    int cff = getF( 1, (1<<20) ) ;
                    ansF += cff;
            //        cout << "+cf\n";
                    if ( cff == 0 ) { break; }
                }

                cout << ansF << "\n";
            }
            i += bSz;

        }


    }
    return 0;
}
/*

5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5


5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5

*/
