#include <iostream>
#include <queue>
#include <vector>

const int MAX_N = 100 + 2;
std::vector<int> graph[MAX_N];
int pipe[MAX_N][MAX_N];
int n;
bool used[MAX_N];
int dist[MAX_N];

int bfs(const int frst) {
	std::queue<std::pair<int, int>> next;
	next.push({frst, 1});
	dist[frst] = 1;
	while(next.size()) {
		auto curr = next.front();
		next.pop();
		for(auto nei : graph[curr.first]) {
			if(dist[nei] == 0) {
				next.push({nei, curr.second + 1});
				dist[nei] = curr.second + 1;
			}
		}
	}
	//for(int i = 0;i < n;i ++) std::cout << i << '.' << dist[i] << std::endl;
}

int aug_path(int curr_node, const int sink, int curr_flow) {
	if(curr_node == sink) {
		return curr_flow;
	}

	//for(int mode = 0;mode < 2;mode ++) {

	for(auto nei : graph[curr_node]) {
		if(used[nei]) continue;
		//if(dist[nei] > dist[curr_node]) continue;
		used[nei] = true;
		const int minf = std::min(curr_flow, pipe[curr_node][nei]);
		if(minf == 0) {
			continue;
			used[nei] = false;
		}
		int f = aug_path(nei, sink, minf);
		used[nei] = false;
		if(f > 0) {
			pipe[curr_node][nei] -= f;
			pipe[nei][curr_node] += f;
			return f;
		}
	}

	/*for(auto nei : graph[curr_node]) {
		if(used[nei]) continue;
		used[nei] = true;
		const int minf = std::min(curr_flow, pipe[curr_node][nei]);
		if(minf == 0) continue;
		int f = aug_path(nei, sink, minf);
		used[nei] = false;
		if(f > 0) {
			pipe[curr_node][nei] -= f;
			pipe[nei][curr_node] += f;
			return f;
		}
	}
	*/

	//}

	return 0;
}

int do_maxflow(const int source, const int sink) {
	std::fill(dist, dist+n, 0);
	bfs(sink);

	int tot = 0;
	while(true) {
		int f = aug_path(source, sink, 1<<30);
		tot += f;
		if(f == 0) break;
	}
	return tot;
}

int main() {
	std::cin.tie(nullptr);
	std::ios::sync_with_stdio(false);

	int m;
	std::cin >> n >> m;
	for(int i = 0;i < m;i ++) {
		int a, b;
		std::cin >> a >> b;
		a --;
		b --;
		graph[a].push_back(b);
		graph[b].push_back(a);
		pipe[a][b] ++;
		pipe[b][a] ++;
	}

	int q;
	std::cin >> q;

	const int source = 0;
	const int sink = n-1;

	int tot = 0;
	tot += do_maxflow(source, sink);

	std::cout << tot << '\n';

	for(int i = 0;i < q;i ++){
		int a, b;
		std::cin >> a >> b;
		a --;
		b --;
		graph[a].push_back(b);
		graph[b].push_back(a);
		pipe[a][b] ++;
		pipe[b][a] ++;

		tot += do_maxflow(source, sink);
		std::cout << tot << std::endl;
	}

	return 0;
}
