#include <iostream>
#include <queue>
#include <vector>
#include <unistd.h>

const int MAX_N = 100 + 2;
std::vector<int> graph[MAX_N];
int _pipe[MAX_N][MAX_N];
bool matt[MAX_N][MAX_N];
int n;
bool used[MAX_N];
int dist[MAX_N];

int bfs(const int frst) {
	std::queue<std::pair<int, int>> next;
	next.push({frst, 1});
	dist[frst] = 1;
	while(next.size()) {
		auto curr = next.front();
		next.pop();
		for(auto nei : graph[curr.first]) {
			if(_pipe[nei][curr.first] <= 0) continue;
			if(dist[nei] == 0) {
				next.push({nei, curr.second + 1});
				dist[nei] = curr.second + 1;
			}
		}
	}
	//for(int i = 0;i < n;i ++) std::cout << i << '.' << dist[i] << std::endl;
}

int aug_path(int curr_node, const int sink, int curr_flow) {
	if(curr_node == sink) {
		return curr_flow;
	}

	for(auto &nei : graph[curr_node]) {
		if(dist[nei] >= dist[curr_node]) continue;
		if(_pipe[curr_node][nei] == 0) continue;
		if(used[nei]) continue;

		used[nei] = true;
		int f = aug_path(nei, sink, 1);
		used[nei] = false;

		if(f > 0) {
			_pipe[curr_node][nei] -= 1;
			_pipe[nei][curr_node] += 1;
			return f;
		}
	}

	return 0;
}

int do_maxflow(const int source, const int sink) {
	std::fill(dist, dist+n, 0);
	bfs(sink);

	int tot = 0;
	while(true) {
		int f = aug_path(source, sink, 1);
		tot += f;
		//std::cout << "add " << f << std::endl;
		if(f == 0) {
			std::fill(dist, dist+n, 0);
			bfs(sink);
			if(dist[source] == 0) { break; }
		}
	}
	return tot;
}

const int BS = 1000000;
int pnt = BS;
char buff[BS];

inline void getint(int &res) {
	res = 0;
	while(true) {
		if(buff[pnt] >= '0' and buff[pnt] <= '9') {
			res *= 10;
			res += buff[pnt] - '0';
			pnt ++;
		} else {
			pnt += 1;
			break;
		}
	}
}

int main() {
	read(0, buff, BS); pnt = 0;
	/*
		for(int i = 0;i < 10;i ++) {
			int a;
			getint(a);
		std::cout << a << std::endl;
	}*/

	int m;
	getint(n);
	getint(m);
	for(int i = 0;i < m;i ++) {
		int a, b;
		getint(a); getint(b);
		a --;
		b --;
		if(!matt[a][b]) {
			graph[a].push_back(b);
			graph[b].push_back(a);
			matt[a][b] = matt[b][a] = true;
		}
		_pipe[a][b] ++;
		_pipe[b][a] ++;
	}

	int q;
	getint(q);

	const int source = 0;
	const int sink = n-1;

	int tot = 0;
	tot += do_maxflow(source, sink);

	std::cout << tot << '\n';

	for(int i = 0;i < q;i ++){
		int a, b;
		getint(a); getint(b);
		a --;
		b --;
		if(!matt[a][b]) {
			graph[a].push_back(b);
			graph[b].push_back(a);
			matt[a][b] = matt[b][a] = true;
		}
		_pipe[a][b] ++;
		_pipe[b][a] ++;

		/*if(i <= 20000)*/ tot += do_maxflow(source, sink);
		std::cout << tot << '\n';
	}

	return 0;
}
