#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <queue>
#include <cstdlib>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e2 + 5;
const int MAX_EDGES = 1e5 + 5 ;
const int INF = 1e9;

int n, m;
int Q;

int NFI = -1;
int id_edge[N][N];

struct edge{

  int from, to;
  int c, f;
  int rev_id;


  edge() {}
  edge(int _from, int _to, int _c, int _rev_id) { from = _from; to = _to; c = _c; rev_id = _rev_id; f = 0; }

};

vector <edge> e;
vector <int> adj[N];

void add_edge(int u, int v)
{
    if(id_edge[u][v])
    {
        e[id_edge[u][v]].c++;
        e[id_edge[v][u]].c++;

        return;
    }

    int last;

    last = NFI + 1;

    e.pb(edge(u, v, 1, last + 1));
    id_edge[u][v] = ++NFI;
    adj[u].pb(NFI);

    e.pb(edge(v, u, 0, last));
    adj[v].pb(++NFI);

    last = NFI + 1;

    e.pb(edge(v, u, 1, last + 1));
    id_edge[v][u] = ++NFI;
    adj[v].pb(NFI);

    e.pb(edge(u, v, 0, last));
    adj[u].pb(++NFI);
}

int vis[N], timestamp;
int pred[N];
queue <int> q;

bool BFS(int t)
{
    timestamp++;
    while(!q.empty())
        q.pop();

    vis[1] = timestamp;
    q.push(1);
    while(!q.empty() && vis[t] != timestamp)
    {
        int v = q.front();
        q.pop();

        vis[v] = timestamp;
        for(int id: adj[v])
        {
            if(e[id].c - e[id].f > 0 && vis[e[id].to] != timestamp)
            {
                pred[e[id].to] = id;
                vis[e[id].to] = timestamp;

                q.push(e[id].to);
            }
        }
    }

    return vis[t] == timestamp;
}

bool DFS(int v)
{
    vis[v] = timestamp;
    for(int id: adj[v])
    {
            if(e[id].c - e[id].f > 0 && vis[e[id].to] != timestamp)
            {
                pred[e[id].to] = id;
                DFS(e[id].to);
            }
    }

    return vis[n] == timestamp;
}

int flow;
void update_flow(int t)
{
   int bottleneck = INF;
   int v = t;
   while(v != 1)
   {
        bottleneck = min(bottleneck, e[pred[v]].c - e[pred[v]].f);
        v = e[pred[v]].from;
   }

   v = t;
   while(v != 1)
   {
       e[pred[v]].f += bottleneck;
       e[e[pred[v]].rev_id].f -= bottleneck;

       v = e[pred[v]].from;
   }

   flow += bottleneck;
}

pair <int, int> inp[MAX_EDGES];

int main()
{
   srand(22255127);

   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);

   int i;
   int u, v;

   cin >> n >> m;
   for(i = 1; i <= m; i++)
   {
       cin >> u >> v;
       inp[i] = mp(u, v);

       add_edge(u, v);
   }

   cin >> Q;

   timestamp++;

   timestamp++;
   while(DFS(1))
   {
       update_flow(n);
       timestamp++;
   }

   cout << flow << endl;
   for(i = 1; i <= Q; i++)
   {
       cin >> u >> v;

       add_edge(u, v);

       timestamp++;
       while(DFS(1))
       {
           update_flow(n);
           timestamp++;
       }

       cout << flow << endl;
   }

   return 0;
}
