#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <queue>
#include <cstdlib>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e2 + 5;
const int MAX_EDGES = 6e4 + 5 ;
const short INF = 4000;

int n, m;
int Q;

int NFI = -1;
int id_edge[N][N];

struct edge{

  short from, to;
  short c, f;
  int rev_id;


  edge() {}
  edge(int _from, int _to, short _c, int _rev_id) { from = _from; to = _to; c = _c; rev_id = _rev_id; f = 0; }

};

vector <edge> e;
vector <int> adj[N];

void add_edge(int u, int v)
{
    if(id_edge[u][v])
    {
        if(e[id_edge[u][v]].c < 4000)
          e[id_edge[u][v]].c++;

        if(e[id_edge[v][u]].c < 4000)
         e[id_edge[v][u]].c++;

        return;
    }

    int last;

    last = NFI + 1;

    e.pb(edge(u, v, 1, last + 1));
    id_edge[u][v] = ++NFI;
    adj[u].pb(NFI);

    e.pb(edge(v, u, 0, last));
    adj[v].pb(++NFI);

    last = NFI + 1;

    e.pb(edge(v, u, 1, last + 1));
    id_edge[v][u] = ++NFI;
    adj[v].pb(NFI);

    e.pb(edge(u, v, 0, last));
    adj[u].pb(++NFI);
}

int vis[N], timestamp;
short pred[N];
queue <short> q;

inline bool BFS(short t)
{
    timestamp++;
    while(!q.empty())
        q.pop();

    vis[1] = timestamp;
    q.push(1);
    while(!q.empty() && vis[t] != timestamp)
    {
        short v = q.front();
        q.pop();

        vis[v] = timestamp;
        for(int id: adj[v])
        {
            if(e[id].c - e[id].f > 0 && vis[e[id].to] != timestamp)
            {
                pred[e[id].to] = id;
                vis[e[id].to] = timestamp;

                q.push(e[id].to);
            }
        }
    }

    return vis[t] == timestamp;
}

short flow;
inline void update_flow(short t)
{
   short bottleneck = INF;
   short v = t;
   while(v != 1)
   {
        short x = e[pred[v]].c - e[pred[v]].f;
        bottleneck = min(bottleneck, x);
        v = e[pred[v]].from;
   }

   v = t;
   while(v != 1)
   {
       e[pred[v]].f += bottleneck;
       e[pred[v]].f = min(e[pred[v]].f, INF);

       e[e[pred[v]].rev_id].f -= bottleneck;
       e[e[pred[v]].rev_id].f = min(e[e[pred[v]].rev_id].f, INF);

       v = e[pred[v]].from;
   }

   flow += bottleneck;
}

short readInt()
{
   char c = getchar();
   short res = 0;

   while(c >= '0' && c <= '9')
   {
       res *= 10;
       res += (int)(c - '0');

       c = getchar();
   }

   return res;
}

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);

   int i;
   short u, v;

  // cin >> n >> m;

   n = readInt(); m = readInt();
   for(i = 1; i <= m; i++)
   {
      // cin >> u >> v;

       u = readInt(); v = readInt();

       add_edge(u, v);
   }

  // cin >> Q;
  Q = readInt();


   while(flow < 4000 && BFS(n))
   {
       update_flow(n);
   }

   cout << flow << endl;
   for(i = 1; i <= Q; i++)
   {
       //cin >> u >> v;
       u = readInt(); v = readInt();

       if(flow == 4000)
       {
           cout << flow << endl;
           continue;
       }

       add_edge(u, v);

       while(BFS(n))
       {
           update_flow(n);
       }

       cout << flow << endl;
   }

   return 0;
}
