#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;
const double TL = 0.17;
int INF;

int n, k;
int p[N], q[N];

int inv_p[N], inv_q[N];

int moves;

int abs(int x)
{
    if(x < 0)
        return -x;
    return x;
}

int val[4 * N];
int query(int pos, int low, int high, int l, int r)
{
    if(l <= low && r >= high)
        return val[pos];
    if(l > high || r < low)
        return 0;

    int mid = (low + high) / 2;

    return query(pos * 2, low, mid, l, r) + query(pos * 2 + 1, mid + 1, high, l, r);
}

void update(int pos, int low, int high, int at, int d)
{
    if(low == high && low == at)
    {
        val[pos] += d;
        return;
    }
    if(at > high || at < low)
    {
        return;
    }

    int mid = (low + high) / 2;

    update(pos * 2, low, mid, at, d);
    update(pos * 2 + 1, mid + 1, high , at, d);
}

int count_inv(int arr[])
{
    memset(val, 0, sizeof(val));
    int res = 0;
    for(int i = 1; i <= n; i++)
    {
        res += query(1, 1, n, arr[i], n);
        update(1, 1, n, arr[i], 1);
    }

    return res;
}

int main()
{
   srand(time(NULL));
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);

   int i;

   cin >> n >> k;
   for(i = 1; i <= n; i++)
   {
       cin >> p[i];
       inv_p[p[i]] = i;
   }
   for(i = 1; i <= n; i++)
   {
       cin >> q[i];
       inv_q[q[i]] = i;
   }

   INF = k;
   while(INF <= n)
     INF += k;

   for(i = 1; i <= n; i++)
   {
        int delta = (inv_q[i] - inv_p[i]) + INF;

        if(delta % k != 0)  /// neobhodimo, no ne dostatuchno uslovie
        {
            moves += inv_q[i] - inv_p[i];

            cout << 0 << endl;
            return 0;
        }
   }

   if(moves != 0)
   {
       cout << 0 << endl;
       return 0;
   }

   int diff = count_inv(p) - count_inv(q) + INF;
   if(k % 2 == 0)
   {
        if(diff % 2 != 0)
        {
            cout << 0 << endl;
            return 0;
        }
   }
   else
   {
       if(diff % 2 == 0)
       {
           cout << 0 << endl;
           return 0;
       }
   }


   cout << 1 << endl;

   return 0;
}


/*

5 2
5 3 2 1 4
2 1 4 3 5

*/
