# include <cstdio>
# include <cstring>
# include <queue>
# include <algorithm>

using namespace std;

const int MAX_N = 1e2 + 10;
const int MAX_K = 5e4 + 10;
const int MAX_E = 1e4 + 10 + 2 * MAX_K;

int n, m;
int k;

int ce;
int to[MAX_E];
int nxt[MAX_E];
int cap[MAX_E];

int head[MAX_N], skip_head[MAX_N];

int lvl[MAX_N];

int mf;

int path[MAX_E], cnt;

void add (int p, int q, int c)
{
	nxt[ce] = head[p];
	to[ce] = q;
	cap[ce] = c;
	head[p] = ce ++;
}

void copy ()
{
	int i;
	for (i = 1; i <= n; i ++)
		skip_head[i] = head[i];
}

void update_path (int cf)
{
	while (cnt)
	{
		cnt --;
		cap[path[cnt]] -= cf;
		cap[path[cnt] ^ 1] += cf;
	}
}

bool bfs (int en)
{
	queue <int> q;
	memset (lvl, -1, sizeof (lvl));
	lvl[en] = 0;
	q.push (en);
	
	while (!q.empty ())
	{
		int crr = q.front ();
		q.pop ();
		for (int e = head[crr]; e != -1; e = nxt[e])
			if (cap[e ^ 1] > 0 && lvl[to[e]] == -1)
			{
				lvl[to[e]] = lvl[crr] + 1;
				q.push (to[e]);
			}
	}
	return (lvl[1] != -1);
}

int dfs (int x)
{
	///printf ("%d %d\n", x, lvl[x]);
	if (x == n)
		return (1 << 30);
	for (int e = skip_head[x]; e != -1; skip_head[x] = e = nxt[e])
		if (cap[e] > 0 && lvl[to[e]] < lvl[x])
		{
			path[cnt ++] = e;
			int cf = dfs (to[e]);
			///printf ("- %d %d %d - %d\n", x, to[e], cap[e], cf); 
			if (cf)
				return min (cf, cap[e]);
			cnt --; 
		}
	
	return 0;
}

void dinic ()
{
	while (bfs (n))
	{
		///printf ("%d %d\n", lvl[1], mf);
		copy ();
		while (1)
		{
			int cf = dfs (1);
			if (!cf)
				break;
			update_path (cf);
			mf += cf;
		}
	}
}

int main ()
{
	memset (head, -1, sizeof (head));
	
	int i, p, q;
	
	scanf ("%d%d", &n, &m);
	
	for (i = 1; i <= m; i ++)
	{
		scanf ("%d%d", &p, &q);
		add (p, q, 1);
		add (q, p, 1);
	}
	
	mf = 0;
	
	dinic ();
	
	printf ("%d\n", mf);
	
	scanf ("%d", &k);
	
	for (i = 0; i < k; i ++)
	{
		scanf ("%d%d", &p, &q);
		add (p, q, 1);
		add (q, p, 1);
		
		dinic ();
		
		printf ("%d\n", mf);
	}
	
	return 0;
}

