#include <cstdio>
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <tuple>
#include <cstdlib>
#include <queue>
#include <map>
#include <unordered_map>
using namespace std;

int n, m, q;
vector<pair<int, int>> queries;
vector<unordered_map<int8_t, int>> gr;

template<typename T> void erase_one(multiset<T> &ms, const T &item)
{
    auto it = ms.find(item);
    auto it1 = it; it1++;
    ms.erase(it, it1);
}

void read()
{
    cin>>n>>m;
    gr.resize(n+1, unordered_map<int8_t, int>{(unsigned)n+1});
    for(int i=0;i<m;i++)
    {
        int x, y;
        cin>>x>>y;
        gr[x][y]++;
        gr[y][x]++;
    }
    cin>>q;
    queries.resize(q);
    for(auto &x : queries)cin>>x.first>>x.second;
}

bool find_road(bool withOptimization = false, int x=-1, int y=-1)
{
    static queue<int8_t> bfs;
    static vector<int8_t> parentOf(n+1);
    static vector<vector<bool>> lastUsed(n+1, vector<bool>(n+1, false));
    static vector<pair<int, int>> lastUsedList;

    if(withOptimization)
    {
        if(lastUsed[x][y])return false;
    }
    else
    {
        for(auto x : lastUsedList)lastUsed[x.first][x.second]=false;
        lastUsedList.clear();
    }

    while(!bfs.empty())bfs.pop();
    fill(parentOf.begin(), parentOf.end(), -1);

    parentOf[1]=-2;
    bfs.push(1);

    while(!bfs.empty())
    {
        int x = bfs.front();
        bfs.pop();

        for(auto y : gr[x])
        {
            if(parentOf[y.first]<0)
            {
                parentOf[y.first]=x;
                bfs.push(y.first);
                lastUsed[x][y.first] = true;
                lastUsedList.emplace_back(x, y.first);
                if(y.first==n)goto found;
            }
        }
    }
    found:

    if(parentOf[n]>0)
    {
        //puts("road: ");
        for(int i=n;i!=1;i=parentOf[i])
        {
            //printf("  %d %d\n", i, parentOf[i]);
            //gr[i].erase(parentOf[i]);
            //gr[parentOf[i]].erase(i);
            //erase_one(gr[parentOf[n]], i);
            gr[parentOf[i]][i]--;
            if(gr[parentOf[i]][i]==0)gr[parentOf[i]].erase(i);
        }
        return true;
    }
    return false;
}

void solve()
{
    int answer = 0;
    while(find_road())answer++;
    printf("%d\n", answer);
    bool optimize = false;
    for(auto x : queries)
    {
        gr[x.first][x.second]++;
        gr[x.second][x.first]++;
        if(find_road(optimize, x.first, x.second)){ answer++; optimize = false;}
        else optimize = true;
        printf("%d\n", answer);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return EXIT_SUCCESS;
}
/**
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0

5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5
**/

