#include<iostream>
#include<stdio.h>
#include<vector>
#include<queue>
using namespace std ;

#define MAXN 107

int maxflow , flow ;
int f[ MAXN ][ MAXN ] ;


int n ;
struct tuhla {
	int to ;
	int flow ;
	int cap ;
	int prv ;
	tuhla ( ) {
		to = flow = cap = prv = 0 ;
	}
	tuhla ( int _to , int _cap , int _prv ) {
		to = _to ;
		flow = 0 ;
		cap = _cap ;
		prv = _prv ;
	}
};

vector < struct tuhla > v ;

int lst[ MAXN ] ;
int dist[ MAXN ] ;

int source , sink ;
int vec_sz = 0 ;


void add_bidirectional ( int x , int y ) {
	if ( f[ x ][ y ] == -1 ) { 
		v.push_back ( tuhla ( y , 1 , lst[ x ] ) ) ;
		vec_sz ++ ;
		f[ x ][ y ] = lst[ x ] = vec_sz - 1 ;
		///v.push_back ( tuhla ( x , 0 , lst[ y ] ) ) ;
		///lst[ y ] = v.size ( ) - 1 ;
		
		v.push_back ( tuhla ( x , 1 , lst[ y ] ) ) ;
		vec_sz ++ ;
		f[ y ][ x ] = lst[ y ] = vec_sz - 1 ;
		///v.push_back ( tuhla ( y , 0 , lst[ x ] ) ) ;
		///lst[ x ] = v.size ( ) - 1 ;
	}
	else {
		v[ f[ x ][ y ] ].cap ++ ;
		v[ f[ y ][ x ] ].cap ++ ;
	}
}

bool bfs ( int vertex ) {
	queue < int > q ;
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		dist[ i ] = -7 ;
	}

	dist[ vertex ] = 0 ;
	q.push ( vertex ) ;
	while ( q.empty ( ) == false ) {
		int x = q.front ( ) ;
		q.pop ( ) ;
		for ( i = lst[ x ] ; i != -7 ; i = v[ i ].prv ) {
			if ( dist[ v[ i ].to ] == -7 ) {
				if ( v[ (i^1) ].flow != v[ (i^1) ].cap ) {
					dist[ v[ i ].to ] = dist[ x ] + 1 ;
					q.push ( v[ i ].to ) ;
				}
			}
		}
	}
	return ( dist[ source ] != -7 ) ;
}

int dfs ( int vertex , int y ) {
	if ( vertex == sink ) { return y ; }
	if ( y == 0 ) { return y ; }
	int i ;
	for ( i = lst[ vertex ] ; i != -7 ; i = v[ i ].prv ) {
		if ( dist[ v[ i ].to ] + 1 == dist[ vertex ] ) {
			if ( v[ i ].flow != v[ i ].cap ) {
				int h = min ( y , v[ i ].cap - v[ i ].flow ) ;
				int go = dfs ( v[ i ].to , h ) ;
				if ( go > 0 ) {
					v[ i ].flow += go ;
					v[ (i^1) ].flow -= go ;
					return go ;
				}
			}
		}
	}
	dist[ vertex ] = -7 ;
	return -7 ;
}

void recalc_maxflow ( ) {
	while ( bfs ( sink ) == true ) {
		while ( 1 ) {
			flow = dfs ( source , MAXN ) ;
			if ( flow < 0 ) { break ; }
			maxflow += flow ;
		}
	}
}

void input ( ) {
	int m ;
	scanf ( "%d%d" , &n , &m ) ;
	int i , j ;
	for ( i = 1 ; i <= n ; i ++ ) {
		lst[ i ] = -7 ;
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		for ( j = 1 ; j <= n ; j ++ ) {
			f[ i ][ j ] = -1 ;
		}
	}	
	while ( m -- ) {
		int x , y ;
		scanf ( "%d%d" , &x , &y ) ;
		add_bidirectional ( x , y ) ;
	}
	source = 1 ;
	sink = n ;
}

void solve ( ) {
	int q ;
	scanf ( "%d" , &q ) ;
	recalc_maxflow ( ) ;
	printf ( "%d\n" , maxflow ) ;
	while ( q -- ) {
		int x , y ;
		scanf ( "%d%d" , &x , &y ) ;
		add_bidirectional ( x , y ) ;
		recalc_maxflow ( ) ;
		printf ( "%d\n" , maxflow ) ;
	}
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
