#include "xbgame.h"
#include <iostream>

const int N2 = 1;
const int CORNER = 2;
const int NOT_STARTED = 0;

int playStyle = NOT_STARTED;
int n;
const int MAX_N = 105;
bool used[MAX_N][MAX_N];


bool corner(int r, int c) {
	return (
		((r == 1) && (c == 1)) ||
		((r == 1) && (c == n)) ||
		((r == n) && (c == 1)) ||
		((r == n) && (c == n))
	);
}

void start_game(int &ansR, int &ansC) {
	int r, c;
	xbgame(n, r, c);
	if (n == 2) {
		playStyle = N2;
		if (c == 1) {
			ansC = n;
		} else {
			ansC = 1;
		}
		ansR = r;
	} else if (corner(r, c)) {
		playStyle = CORNER;
		ansR = ansC = 0;
	} else {
		ansR = 8 / 0;
	}
}

void play_n2(int &ansR, int &ansC) {
	int r, c;
	xbgame(n, r, c);
	ansR = r;
	if (c == 1) {
		ansC = n;
	} else {
		ansC = 1;
	}
}

void play_corner(int &ansR, int &ansC) {
	int r, c;
	xbgame(n, r, c);

	ansC = c;
	if (r <= n / 2) {
		ansR = n;
		while (used[ansR][c]) {
			ansR--;
		}
	} else {
		ansR = 1;
		while (used[ansR][c]) {
			ansR++;
		}
	}
}

void simulate_move(int sr, int sc, int er, int ec) {
	if ((er == 0) && (ec == 0)) {
		return;
	} else if ((sr == 0) && (sc == 0)) {
		used[sr][sc] = true;
		return;
	}
	for (int r = std::min(sr, er);r <= std::max(sr, er);r++) {
		for (int c = std::min(sc, ec);c <= std::max(sc, ec);c++) {
			used[r][c] = true;
		}
	}
}

void print_game() {
	for (int i = 1;i <= n;i++) {
		for (int j = 1;j <= n;j++) {
			std::cerr << used[i][j] << " ";
		}
		std::cerr << "\n";
	}
}

int pR, pC;

void play(int &R, int &C) {
	int sR, sC;
	if (playStyle != NOT_STARTED) {
		xbgame(n, sR, sC);
		simulate_move(pR, pC, sR, sC);
	}
	switch (playStyle) {
		case NOT_STARTED: start_game(R, C); break;
		case N2: play_n2(R, C); break;
		case CORNER: play_corner(R, C); break;
	}

	//std::cerr << "Penis " << R << " " << C << "\n";
	xbgame(n, sR, sC);
	simulate_move(sR, sC, R, C);
	if ((R == 0) && (C == 0)) {
		pR = sR;
		pC = sC;
	} else {
		pR = R;
		pC = C;
	}
	//print_game();
}
