#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 1e5;

int32_t n, k, aCpy[MAX_N + 5], a[MAX_N + 5], newVals[MAX_N + 5];
vector< int32_t > numsOn[MAX_N / 2 + 5];

int32_t CountInv(const vector< int32_t > &v) {
	int32_t n = (int32_t) v.size(), cnt = 0;

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = i - 1; j >= 0; j--) {
			if(v[i] < v[j]) {
				cnt++;
			}
		}
	}

	return cnt;
}

bool Greedy1() {
	while(1) {
		int32_t maxIncome = -n, ind;

		for(int32_t i = 1; i <= n - 2 * k + 1; i++) {
			vector< int32_t > v1(2 * k), v2(2 * k);
			for(int32_t j = 0; j < k; j++) {
				v1[j] = a[i + j];
				v2[j + k] = a[i + j];
			}

			for(int32_t j = k; j < 2 * k; j++) {
				v1[j] = a[i + j];
				v2[j - k] = a[i + j];
			}

			int32_t cntInv1 = CountInv(v1);
			int32_t cntInv2 = CountInv(v2);

			int32_t income = cntInv1 - cntInv2;

			if(income > maxIncome) {
				maxIncome = income;
				ind = i;
			}
		}
		
		if(maxIncome <= 0) {
			break;
		}

		for(int32_t i = ind; i < ind + k; i++) {
			swap(a[i], a[i + k]);
		}
	}

	for(int32_t i = 2; i <= n; i++) {
		if(a[i] < a[i - 1]) {
			for(int32_t i = 1; i <= n; i++) {
				a[i] = aCpy[i];
			}
			
			return false;
		}
	}

	for(int32_t i = 1; i <= n; i++) {
		a[i] = aCpy[i];
	}
	return true;
}

bool CheckIsSorted() {
	for(int32_t i = 1; i <= k; i++) {
		for(int32_t j = 1; j < (int32_t) numsOn[i].size(); i++) {
			if(numsOn[i][j] < numsOn[i][j - 1]) {
				return false;
			}
		}
	}

	return true;
}

bool CanSort() {
	while(1) {
		bool haveChange = false;

		for(int32_t j = 1; j < (int32_t) numsOn[1].size(); j++) {
			if(numsOn[1][j - 1] > numsOn[1][j]) {
				swap(numsOn[1][j - 1], numsOn[1][j]);
				haveChange = true;

				bool swapedColumns = false;
				for(int32_t p = 2; p <= k; p++) {
					if(j > 1 && numsOn[p][j - 1] < numsOn[p][j - 2]) {
						swap(numsOn[p][j - 1], numsOn[p][j - 2]);
						swapedColumns = true;
					}
					else if(swapedColumns) {
						return false;
					}
					else { 
						swap(numsOn[p][j - 1], numsOn[p][j]);
					}
				}
			}
		}

		if(!haveChange) {
			break;
		}
	}
	
	CheckIsSorted();
}

bool Greedy2() {
	for(int32_t i = 1; i <= n; i++) {
		numsOn[(i % k == 0 ? k : i % k)].push_back(a[i]);
	}
	
	if(!CanSort()) {
		return false;
	}
	
	for(int32_t i = 1; i <= k; i++) {
		sort(numsOn[i].begin(), numsOn[i].end());
	}

	int32_t nxt = 1;
	for(int32_t i = 0; i < n / k + 1; i++) {
		for(int32_t j = 1; j <= k; j++) {
			if((int32_t) numsOn[j].size() > i) {
				if(nxt != numsOn[j][i]) {
					return false;
				}

				nxt++;
			}
		}
	}

	return true;
}

bool Greedy3() {
	for(int32_t i = 1; i <= n; i++) {
		int32_t indOfI;

		for(int32_t j = 1; j <= n; j++) {
			if(a[j] == i) {
				indOfI = j;
				break;
			}
		}
		
		while(indOfI != i) {
			int32_t indOfSwap;
			if(indOfI + k - 1 <= n) {
				indOfSwap = indOfI;
			}
			else {
				indOfSwap = indOfI - ((indOfI + k - 1) - n);
			}

			if(indOfSwap <= k) {
				return false;
			}
			
			for(int32_t j = indOfSwap; j < indOfSwap + k; j++) {
				swap(a[j], a[j - k]);

				if(a[j - k] == i) {
					indOfI = j - k;
				}
			}

			if(indOfI < i) {
				return false;
			}
		}
	}

	return true;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> n >> k;

	for(int32_t i = 1; i <= n; i++) {
		cin >> a[i];
	}

	for(int32_t i = 1; i <= n; i++) {
		int32_t x;
		cin >> x;
		
		newVals[x] = i;
	}

	for(int32_t i = 1; i <= n; i++) {
		a[i] = newVals[a[i]];
		aCpy[i] = a[i];
	}
	
	bool p = false;
	//p |= Greedy1();
	p |= Greedy2();
	if(n <= 10000) {
		p |= Greedy3();	
	}	

	cout << p << endl;
}
