#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define MAXN 110

using namespace std;

int n, m, Q, x, y;
vector <int> G[MAXN];
bool used[MAXN], temp[MAXN];
int routes[MAXN];
queue <int> q;

void init() {	
	for (int i = 0; i < MAXN; i++) {
		used[i] = false;
		temp[i] = false;
		routes[i] = 0;
	}	
	
	while (q.size() > 0) q.pop();
}

int findRoutes(int start) {
	init();
	used[start] = true;
	q.push(start);
	
	while (true) {
		int FRONT = q.front(); q.pop();
		used[FRONT] = true;
		
		for (int i = 0; i < G[FRONT].size(); i++)
			if (!used[G[FRONT][i]]) {
				if (!temp[G[FRONT][i]]) {
					q.push(G[FRONT][i]);
					if (G[FRONT][i] != G[FRONT][i+1]) temp[G[FRONT][i]] = true;
				}
				if (routes[G[FRONT][i]] > 0) routes[FRONT]++;
				routes[G[FRONT][i]]++;
			}
		if (q.size() == 0) break;
	}
	
	return routes[n];
}

int main() {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		G[x].push_back(y);
		G[y].push_back(x);
	}
	
	for (int i = 1; i <= n; i++)
		sort(G[i].begin(), G[i].end());
	
	cout << findRoutes(1) << "\n";
	cin >> Q;
	for (int i = 0; i < Q; i++) {
		cin >> x >> y;
		G[x].push_back(y);
		G[y].push_back(x);
		sort(G[x].begin(), G[x].end());
		sort(G[y].begin(), G[y].end());
		cout << findRoutes(1) << "\n";
	}
	return 0;
}
