#include "xbgame.h"
#include <vector>
#include <iostream>
#include <stdlib.h>

#define random(x) (rand() % x)
#define rnd(lo,hi) ((lo) + (random(((hi)-(lo)+1))))

using namespace std;

int N,Row,Col;
bool Start=true;
bool T[102][102];
bool H=true;

void initT()
{
    for (int i=1; i<=N; i++)
        for (int j=1; j<=N; j++) T[i][j]=false;
    for (int i=0; i<=N+1; i++)
    {
        T[0][i]=true;
        T[N+1][i]=true;
        T[i][0]=true;
        T[i][N+1]=true;
    }
    T[Row][Col]=true;
}

void makeMove(int R,int C,bool H)
{
    T[Row][Col]=true;
    if (H)
    {
        int st=(Col<C?-1:1);
        for (int i=C; i!=Col; i+=st) T[Row][i]=true;
    }
    else
    {
        int st=(Row<R?-1:1);
        for (int i=R; i!=Row; i+=st) T[i][Col]=true;
    }
    Row=R;
    Col=C;
}
void getMove(int &R, int &C)
{
    bool succ=0;
    int d1=0,d2=0;
    if (H)
    {
        R=Row;
        for(int i=Col+1; !T[Row][i]; i++)
        {
            d1=i-Col;
            if (T[Row-1][i] && T[Row+1][i])
            {
                succ=1;
                break;
            }
        }
        if (succ)
        {
            C=Col+d1;
            return;
        }
        for(int i=Col-1; !T[Row][i]; i--)
        {
            d2=Col-i;
            if (T[Row-1][i] && T[Row+1][i])
            {
                succ=1;
                break;
            }
        }
        if (succ)
        {
            C=Col-d2;
            return;
        }
        if (d1>d2)
        {
            C=Col+d1;
        }
        else
        {
            C=Col-d2;
        }

    }
    else
    {
        C=Col;
        for (int i=Row+1; !T[i][Col]; i++)
        {
            d1=i-Row;
            if (T[i][Col-1] && T[i][Col+1])
            {
                succ=1;
                break;
            }
        }
        if (succ)
        {
            R=Row+d1;
            return;
        }
        for (int i=Row-1; !T[i][Col]; i--)
        {
            d2=Row-i;
            if (T[i][Col-1] && T[i][Col+1])
            {
                succ=1;
                break;
            }
        }
        if (succ)
        {
            R=Row-d2;
            return;
        }
        if (d1>=d2)
        {
            R=Row+d1;
        }
        else
        {
            R=Row-d2;
        }
    }
}

void play(int &R,int &C)
{
    xbgame(N,R,C);
    if (Start)
    {
        Row=R;
        Col=C;
        initT();
        Start=false;
        /*if (rnd(0,1))
        {
            R=C=0;
            H=false;
            return;//skip first move
        }*/
        getMove(R,C);
        makeMove(R,C,H);
        return;
    }
    makeMove(R,C,!H);//executing opponent's move
    getMove(R,C);//get next move
    makeMove(R,C,H);//execute the move
}
