#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 107;
const int INF = (1e9) + 7;

struct edge {
  int to,reversed,flow,capacity;

  edge(){}
  edge(int a, int b, int c) {
    to=a;
    reversed=b;
    flow=0;
    capacity=c;
  }
};

int n,m,q,ptr[N],dist[N];
vector < edge > v[N];
bool used[N];
int max_flow;
pair < int, int > e1[5000],e2[50007];
bool vis[50007];
int rem[50007];
int answer[50007];
set < int > evaluated;

void add_edge(int a, int b) {
  edge x=edge(b,v[b].size(),1);
  edge y=edge(a,v[a].size(),1);

  v[a].push_back(x);
  v[b].push_back(y);
}

bool bfs() {
  int i,curr;
  queue < int > q;

  fill(used+1,used+1+n,false);

  used[1]=true;
  dist[1]=0;
  q.push(1);

  while(!q.empty()) {
    curr=q.front();
    q.pop();

    for(i=0;i<(int)(v[curr].size());i++) if(!used[v[curr][i].to] && v[curr][i].flow<v[curr][i].capacity) {
      used[v[curr][i].to]=true;
      dist[v[curr][i].to]=dist[curr]+1;
      q.push(v[curr][i].to);
    }
  }

  return used[n];
}

int dfs(int node, int flow) {
  if(node==n) return flow;

  int i,transmitted=0;

  for(i=ptr[node];i<(int)(v[node].size());i++,ptr[node]++) {
    if(dist[v[node][i].to]==dist[node]+1 && v[node][i].flow<v[node][i].capacity) {
      transmitted=dfs(v[node][i].to,min(flow,v[node][i].capacity-v[node][i].flow));

      if(transmitted>0) {
        v[node][i].flow+=transmitted;
        v[v[node][i].to][v[node][i].reversed].flow-=transmitted;

        return transmitted;
      }
    }
  }

  return 0;
}

int find_flow() {
  int ans=0;

  while(bfs()) {
    int to_add;

    fill(ptr+1,ptr+1+n,0);
    
    while((to_add=dfs(1,INF))>0) {
      ans+=to_add;
    }
  }

  return ans;
}

int eval(int pos) {
  if(vis[pos]) return rem[pos];

  int i;

  for(i=1;i<=n;i++) {
    v[i].clear();
  }

  for(i=1;i<=m;i++) {
    add_edge(e1[i].first,e1[i].second);
  }

  for(i=1;i<=pos;i++) {
    add_edge(e2[i].first,e2[i].second);
  }

  evaluated.insert(pos);
  vis[pos]=true;
  return rem[pos]=find_flow();
}

void set_answer(int l, int r, int v) {
  for(int i=l;i<=r;i++) {
    answer[i]=v;
  }
}

int get_middle(int l, int r) {
  set < int >::iterator it=evaluated.upper_bound(l);

  if(it!=evaluated.end()) if(*it<r) return *it;

  return (l+r)/2;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i,x,y,left,right,middle,last,initial;
  
  scanf("%d %d", &n, &m);
  for(i=1;i<=m;i++) {
    scanf("%d %d", &e1[i].first, &e1[i].second);
  }

  scanf("%d", &q);
  for(i=1;i<=q;i++) {
    scanf("%d %d", &e2[i].first, &e2[i].second);
  }

  for(i=0;i<=q;i+=100) eval(i);

  initial=eval(0);
  last=0;

  for(i=initial+1;;i++) {
    left=last;
    right=q+1;
    
    while(right-left>1) {
      middle=get_middle(left,right);
      if(eval(middle)>=i) right=middle;
      else left=middle;
    }
    
    set_answer(last,right-1,i-1);

    if(right==q+1) {
      break;
    }

    last=right;
  }

  for(i=0;i<=q;i++) {
    printf("%d\n", answer[i]);
  }

  return 0;
}
