#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 107;
const int INF = (1e9) + 7;

struct edge {
  int to,reversed,flow,capacity;

  edge(){}
  edge(int a, int b, int c) {
    to=a;
    reversed=b;
    flow=0;
    capacity=c;
  }
};

int n,m,q,ptr[N],dist[N];
vector < edge > v[N];
bool used[N];
int max_flow;

int parents[N],sz[N];

void initialize_dsu() {
  for(int i=1;i<=n;i++) {
    parents[i]=i;
    sz[i]=1;
  }
}

int find(int x) {
  while(x!=parents[x]) {
    parents[x]=parents[parents[x]];
    x=parents[x];
  }
  
  return x;
}

void join(int x, int y) {
  x=find(x);
  y=find(y);

  if(x==y) return;

  if(sz[x]>=sz[y]) {
    sz[x]+=sz[y];
    parents[y]=x;
  }
  else {
    sz[y]+=sz[x];
    parents[x]=y;
  }
}

void add_edge(int a, int b) {
  edge x=edge(b,v[b].size(),1);
  edge y=edge(a,v[a].size(),1);

  v[a].push_back(x);
  v[b].push_back(y);
}

bool bfs() {
  int i,curr;
  queue < int > q;

  fill(used+1,used+1+n,false);

  used[1]=true;
  dist[1]=0;
  q.push(1);

  while(!q.empty()) {
    curr=q.front();
    q.pop();

    for(i=0;i<(int)(v[curr].size());i++) if(!used[v[curr][i].to] && v[curr][i].flow<v[curr][i].capacity) {
      used[v[curr][i].to]=true;
      dist[v[curr][i].to]=dist[curr]+1;
      q.push(v[curr][i].to);
    }
  }

  return used[n];
}

int dfs(int node, int flow) {
  if(node==n) return flow;

  int i,transmitted=0;

  for(i=ptr[node];i>=0;i--,ptr[node]--) {
    if(dist[v[node][i].to]==dist[node]+1 && v[node][i].flow<v[node][i].capacity) {
      transmitted=dfs(v[node][i].to,min(flow,v[node][i].capacity-v[node][i].flow));

      if(transmitted>0) {
        v[node][i].flow+=transmitted;
        v[v[node][i].to][v[node][i].reversed].flow-=transmitted;

        return transmitted;
      }
    }
  }

  return 0;
}

void find_flow() {
  while(bfs()) {
    int to_add;

    for(int i=1;i<=n;i++) ptr[i]=(int)(v[i].size())-1;

    while((to_add=dfs(1,INF))>0) {
      max_flow+=to_add;
    }
  }

  /*initialize_dsu();

  for(int i=1;i<=n;i++) for(int j=0;j<(int)(v[i].size());j++) {
    if(v[i][j].flow<v[i][j].capacity && v[v[i][j].to][v[i][j].reversed].flow<v[v[i][j].to][v[i][j].reversed].capacity) join(i,v[i][j].to);
  }*/
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i,x,y;
  
  scanf("%d %d", &n, &m);
  
  //initialize_dsu();
  
  for(i=1;i<=m;i++) {
    scanf("%d %d", &x, &y);
    add_edge(x,y);
    //join(x,y);
  }

  //if(find(1)==find(n)) find_flow();
  find_flow();
  printf("%d\n", max_flow);

  scanf("%d", &q);
  while(q--) {
    scanf("%d %d", &x, &y);
    add_edge(x,y);
    //join(x,y);
    //if(find(1)==find(n)) find_flow();
    find_flow();
    printf("%d\n", max_flow);
  }
  
  return 0;
}
