#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 107;
const int INF = (1e9) + 7;

struct edge {
  int to,reversed,flow,capacity;

  edge(){}
  edge(int a, int b, int c) {
    to=a;
    reversed=b;
    flow=0;
    capacity=c;
  }
};

int n,m,q,ptr[N],dist[N];
vector < edge > v[N];
bool used[N];
int max_flow;

void add_edge(int a, int b) {
  edge x=edge(b,v[b].size(),1);
  edge y=edge(a,v[a].size(),1);

  v[a].push_back(x);
  v[b].push_back(y);
}

bool bfs() {
  int i,curr;
  queue < int > q;

  fill(used+1,used+1+n,false);

  used[1]=true;
  dist[1]=0;
  q.push(1);

  while(!q.empty()) {
    curr=q.front();
    q.pop();

    for(i=0;i<(int)(v[curr].size());i++) if(!used[v[curr][i].to] && v[curr][i].flow<v[curr][i].capacity) {
      used[v[curr][i].to]=true;
      dist[v[curr][i].to]=dist[curr]+1;
      q.push(v[curr][i].to);
    }
  }

  return used[n];
}

int dfs(int node, int flow) {
  if(node==n) return flow;

  int i,transmitted=0;

  for(i=ptr[node];i<(int)(v[node].size());i++,ptr[node]++) {
    if(dist[v[node][i].to]==dist[node]+1 && v[node][i].flow<v[node][i].capacity) {
      transmitted=dfs(v[node][i].to,min(flow,v[node][i].capacity-v[node][i].flow));

      if(transmitted>0) {
        v[node][i].flow+=transmitted;
        v[v[node][i].to][v[node][i].reversed].flow-=transmitted;

        return transmitted;
      }
    }
  }

  return 0;
}

void find_flow() {
  while(bfs()) {
    int to_add;

    fill(ptr+1,ptr+1+n,0);
    
    while((to_add=dfs(1,INF))>0) {
      max_flow+=to_add;
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i,x,y;
  
  scanf("%d %d", &n, &m);
  for(i=1;i<=m;i++) {
    scanf("%d %d", &x, &y);
    add_edge(x,y);
  }

  find_flow();
  printf("%d\n", max_flow);

  scanf("%d", &q);
  while(q>0) {
    --q;
    scanf("%d %d", &x, &y);
    add_edge(x,y);
    find_flow();
    printf("%d\n", max_flow);
    if(max_flow==4000) {
      while(q>0) {
        --q;
        printf("4000\n");
      }
    }
  }
  
  return 0;
}
