#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;
const int INF = (1e9) + 7;

struct xorshift {
  unsigned long long x,y,z,w;

  xorshift(): x(123456789101112), y(837298239832), z(77777777777777), w(872398732988923) {}

  unsigned long long next() {
    unsigned long long t=x^(x<<11);

    x=y;y=z;z=w;

    return w=w^(w>>19)^t^(t>>8);
  }
} rng;

struct node {
  int value,min_value;

  unsigned long long priority;
  unsigned size;

  node *left, *right;
};

typedef node *node_ptr;

int n,k,a[N],b[N],pos[N];
node_ptr root;
int arr[N],arr_sz;

node_ptr new_node(int value) {
  node_ptr res=(node_ptr)malloc(sizeof(node));

  res->value=value;
  res->min_value=value;

  res->priority=rng.next();
  res->size=1;

  res->left=NULL;
  res->right=NULL;

  return res;
}

unsigned get_size(node_ptr &a) {
  if(a==NULL) return 0;
  return a->size;
}

int get_value(node_ptr &a) {
  if(a==NULL) return INF;
  return a->value;
}

int get_min_value(node_ptr &a) {
  if(a==NULL) return INF;
  return a->min_value;
}

void update_node(node_ptr &a) {
  if(a==NULL) return;

  a->size=1+get_size(a->left)+get_size(a->right);
  a->min_value=min(a->value, min(get_min_value(a->left), get_min_value(a->right)));
}

void split(node_ptr t, node_ptr &l, node_ptr &r, unsigned key) { //TODO
  if(t==NULL) l=NULL,r=NULL;
  else if(key<=get_size(t->left)) {
    split(t->left,l,t->left,key);
    r=t;

    update_node(l);
    update_node(r);
  }
  else {
    split(t->right,t->right,r,key-1-get_size(t->left));
    l=t;

    update_node(r);
    update_node(l);
  }
}

void merge(node_ptr &t, node_ptr l, node_ptr r) {
  if(l==NULL) t=r;
  else if(r==NULL) t=l;
  else if(l->priority>r->priority) {
    merge(l->right,l->right,r);
    t=l;
  }
  else {
    merge(r->left,l,r->left);
    t=r;
  }

  update_node(t);
}

int get_idx(node_ptr &t) {
  if(t->value==t->min_value) return 1+get_size(t->left);
  else if(get_min_value(t->left)==t->min_value) return get_idx(t->left);
  else return 1+get_size(t->left)+get_idx(t->right);
}

void get_arr(node_ptr &a) {
  if(a==NULL) return;
  get_arr(a->left);
  arr[++arr_sz]=a->value;
  get_arr(a->right);
}

bool is_sorted() {
  int i;

  for(i=2;i<=arr_sz;i++) if(arr[i-1]>arr[i]) return false;
  
  return true;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i,sz;
  node_ptr t1,t2,t3,t4;

  scanf("%d %d", &n, &k);
  for(i=1;i<=n;i++) {
    scanf("%d", &a[i]);
  }
  for(i=1;i<=n;i++) {
    scanf("%d", &b[i]);
    pos[b[i]]=i;
  }
  for(i=1;i<=n;i++) {
    a[i]=pos[a[i]];
    if(abs(a[i]-i)%k>0) {
      printf("0\n");
      return 0;
    }
  }
 
  root=NULL;
  for(i=1;i<=n;i++) {
    merge(root,root,new_node(a[i]));
  }

  int curr=root->min_value,pos=get_idx(root);

  //printf("%d %d\n", curr, pos);
  
  while((sz=(int)(get_size(root)))>2*k) {
    int curr=root->min_value,pos=get_idx(root);

    //printf("curr = %d, pos = %d\n", curr, pos);

    if(pos>sz-k+1) {
      //Perform a single swap

      t1=NULL;
      t2=NULL;
      t3=NULL;
      t4=NULL;

      split(root,t1,t2,sz-2*k);
      split(t2,t2,t3,k);
      split(t3,t3,t4,k);

      merge(t2,t3,t2);
      merge(t1,t1,t2);
      merge(root,t1,t4);

      continue;
    }
    
    t1=NULL;
    t2=NULL;
    t3=NULL;

    split(root,t1,t2,pos-1);
    split(t2,t2,t3,k);
    merge(t1,t1,t3);
    merge(root,t2,t1);

    t1=NULL;
    split(root,t1,root,1);
  }

  get_arr(root);

  assert(arr_sz==2*k);

  if(is_sorted()) {
    printf("1\n");
    return 0;
  }

  for(i=1;i<=k;i++) {
    swap(arr[i],arr[i+k]);
  }

  if(is_sorted()) {
    printf("1\n");
  }
  else {
    printf("0\n");
  }

  return 0;
}
