#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>

#define endl '\n'

using namespace std;

int n, m, Q, a, b, parent[128], BestWay[128], br=0;

bool used[128];
int v[128][128];
queue<int> q;
vector<pair<pair<int, int>, int> > backup;

bool bfs(int curr)
{
    for(int i=1; i<=n; ++i)
    {
        used[i]=0;
        parent[i]=-1;
        BestWay[i]=(int)(1e9);
    }
    used[curr]=1;
    q.push(curr);
    BestWay[curr]=0;
    parent[curr]=curr;
    while(!q.empty())
    {
        a=q.front();
        q.pop();
        for(int i=1; i<=n; ++i)
        {
            if(v[i][a]<1)
            {
                continue;
            }
            if(!used[i])
            {
                used[i]=1;
                if(BestWay[i]>BestWay[a]+1)
                {
                    BestWay[i]=BestWay[a]+1;
                    parent[i]=a;
                }
                q.push(i);
            }
        }
    }
    if(parent[n]==-1) return false;
    a=n;
    while(1)
    {
        if(a==1) break;
        b=parent[a];
        backup.push_back({{a, b}, v[a][b]});
        v[a][b]--;
        v[b][a]--;
        a=b;
    }
    return true;
}

int main ()
{
    //freopen("i1.txt", "r", stdin);
    ios::sync_with_stdio(false);cin.tie(NULL);
    cin>>n>>m;
    for(int i=0; i<m; ++i)
    {
        cin>>a>>b;
        v[a][b]=v[b][a]=1;
    }
    cin>>Q;
    while(bfs(1))
    {
        br++;
    }
    for(auto i:backup)
    {
        //cout<<"restoring "<<i.first.first<<" and "<<i.first.second<<" with "<<i.second<<endl;
        v[i.first.first][i.first.second]=i.second;
        v[i.first.second][i.first.first]=i.second;
    }
    backup.clear();
    cout<<br<<endl;
    while(Q--)
    {
        cin>>a>>b;
        v[a][b]++;
        v[b][a]++;
        br=0;
        while(bfs(1))
        {
            br++;
        }
        for(auto i:backup)
        {
            //cout<<"restoring "<<i.first.first<<" and "<<i.first.second<<" with "<<i.second<<endl;
            v[i.first.first][i.first.second]=i.second;
            v[i.first.second][i.first.first]=i.second;
        }
        backup.clear();
        cout<<br<<endl;
    }
    return 0;
}
/*
8 10
1 2
1 3
1 4
2 5
3 6
3 7
4 8
5 8
6 8
7 8
12
*/
