#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include <vector>

#include "Jxbgame.cpp"

#define randomize() (srand(time(0)))
#define random(x) (rand() % x)
#define rnd(lo,hi) ((lo) + (random(((hi)-(lo)+1))))

#define trace

using namespace std;
int n,r,c;
bool first=true;
bool t[102][102];
bool h=false;
void xbgame(int &N, int &R, int &C)
{N=n;R=r;C=c;
}
bool legal(int R,int C,bool h)
{if (R<1 || R>n || C<1 || C>n) return false;
 if (h && R!=r || !h && C!=c) return false;
 if (h)
 {for (int i=c+1;i<=C;i++) if (t[R][i]) return false;
  for (int i=c-1;i>=C;i--) if (t[R][i]) return false;
 }
 else
 {for (int i=r+1;i<=R;i++) if (t[i][C]) return false;
  for (int i=r-1;i>=R;i--) if (t[i][C]) return false;
 }
 return true;
}
void execMove(int R,int C,bool h)
{if (h)
 {for (int i=c+1;i<=C;i++) t[R][i]=true;
  for (int i=c-1;i>=C;i--) t[R][i]=true;
 }
 else
 {for (int i=r+1;i<=R;i++) t[i][C]=true;
  for (int i=r-1;i>=R;i--) t[i][C]=true;
 }
 r=R;c=C;
}
bool winning(int &R,int &C)
{if (h)
 {for (int i=c-1;!t[r][i];i--) if (t[r-1][i] && t[r+1][i]){R=r;C=i;return true;}
  for (int i=c+1;!t[r][i];i++) if (t[r-1][i] && t[r+1][i]){R=r;C=i;return true;}
 }
 else
 {for (int i=r-1;!t[i][c];i--) if (t[i][c-1] && t[i][c+1]){R=i;C=c;return true;}
  for (int i=r+1;!t[i][c];i++) if (t[i][c-1] && t[i][c+1]){R=i;C=c;return true;}
 }
 return false;
}
void nextX(int &R,int &C)
{vector<int> a;
 int m=n,p;
 for (int i=c-1;!t[r][i];i--)
 {p=0;
  for (int j=r-1;!t[j][i];j--) p++;
  for (int j=r+1;!t[j][i];j++) p++;
  if (p==m) a.push_back(i);
  else if (p<m) {m=p;a.clear();a.push_back(i);}
 }
 for (int i=c+1;!t[r][i];i++)
 {p=0;
  for (int j=r-1;!t[j][i];j--) p++;
  for (int j=r+1;!t[j][i];j++) p++;
  if (p==m) a.push_back(i);
  else if (p<m) {m=p;a.clear();a.push_back(i);}
 }
 C=a[rnd(0,a.size()-1)];
 R=r;
}
void nextB(int &R,int &C)
{vector<int> a;
 int m=n,p;
 for (int i=r-1;!t[i][c];i--)
 {p=0;
  for (int j=c-1;!t[i][j];j--) p++;
  for (int j=c+1;!t[i][j];j++) p++;
  if (p==m) a.push_back(i);
  else if (p<m) {m=p;a.clear();a.push_back(i);}
 }
 for (int i=r+1;!t[i][c];i++)
 {p=0;
  for (int j=c-1;!t[i][j];j--) p++;
  for (int j=c+1;!t[i][j];j++) p++;
  if (p==m) a.push_back(i);
  else if (p<m) {m=p;a.clear();a.push_back(i);}
 }
 R=a[rnd(0,a.size()-1)];
 C=c;
}
int nextMove(int &R,int &C)
{if (h)
 {if (t[r][c-1] && t[r][c+1]) {R=C=0;return 2;}//no move
 }
 else
 {if (t[r-1][c] && t[r+1][c]) {R=C=0;return 2;}//no move
 }
 if (winning(R,C)) return 1;//winning move
 if (h) nextX(R,C);
 else nextB(R,C);
 return 0;
}
void showT()
{for (int i=0;i<=n+1;i++)
 {for (int j=0;j<=n+1;j++) cout<<((!i||!j||i>n||j>n)?'*':(char)('0'+t[i][j]));
  cout<<endl;
 }
 char b[4];
 cout<<"Press <ENTER> to continue...";
 cin.getline(b,4);
}
void init()
{for (int i=1;i<=n;i++)
  for (int j=1;j<=n;j++) t[i][j]=false;
 for (int i=0;i<=n+1;i++)
 {t[0][i]=true;
  t[n+1][i]=true;
  t[i][0]=true;
  t[i][n+1]=true;
 }
 t[r][c]=true;
}
string answer(int &R, int &C)
{switch(nextMove(R,C))
 {case 1: return "Player loses";
  case 2: return "Player wins";
 }
 return "OK";
}

int main()
{string a;
 randomize();
 int row,col;
 cin>>n>>r>>c;
 cin.ignore();
 init();
 do
 {
#ifdef trace
cout<<"\nCurrent state:\n";
cout<<"Pawn at row="<<r<<", col="<<c<<endl;
if (!first) cout<<"Player plays "<<(!h?'X':'B')<<", Jury plays "<<(h?'X':'B')<<endl;
showT();
#endif // trace
  play(row,col);
#ifdef trace
cout<<"Received from player: move to row="<<row<<", col="<<col<<endl;
#endif // trace
  if (first)
  {first=false;
   h=!row;
   if (h) {answer(row,col);
           execMove(row,col,h);
#ifdef trace
cout<<"Player wants to play B.\n";
cout<<"Jury moves to row="<<row<<", col="<<col<<endl;
#endif // trace
           a="OK";
           continue;
          }
  }
#ifdef trace
cout<<"Checking player's move from r="<<r<<", c="<<c<<" to row="<<row<<", col="<<col<<endl;
#endif // trace
  if (legal(row,col,!h)) execMove(row,col,!h);
  else {a="Incorrect move";break;}
  a=answer(row,col);
  if (a=="OK")
  {execMove(row,col,h);
#ifdef trace
cout<<"Jury moves to row="<<row<<", col="<<col<<endl;
#endif // trace
  }
 }while (a=="OK");
#ifdef trace
cout<<"\nFinal state:\n";
cout<<"Pawn at row="<<r<<", col="<<c<<endl;
if (!first) cout<<"Player plays "<<(!h?'X':'B')<<", Jury plays "<<(h?'X':'B')<<endl;
showT();
#endif // trace
 cout<<a;
#ifdef trace
if (a=="Player loses") cout<<" after jury's move to row "<<row<<", column "<<col;
#endif // trace
 cout<<".\n";
 return 0;
}
