#include <iostream>
#include <utility>
#define fi first
#define se second
using namespace std;

void xbgame (int &N, int &R, int &C)
/*{
    cout << "next move" << endl;
    cin >> N >> R >> C;
    if (N == -1)
    {
        cout << "win" << endl;
    }
}//*/
;

const int MAXN = 128;

int n, r, c;
bool start = true, s1 = false, s2 = false;
int role = 0;

bool mat[MAXN][MAXN];
pair<int, int> pm;

pair<int, int> makeMove(pair<int, int> p)
{
    int dir;
    if (p.se - 1 >= 1 and mat[p.fi][p.se - 1] == 0) dir = -1;
    if (p.se + 1 <= n and mat[p.fi][p.se + 1] == 0) dir = +1;

    while (p.se + dir >= 1 and p.se + dir <= n and mat[p.fi][p.se + dir] == 0)
    {
        p.se += dir;
        mat[p.fi][p.se] = 1;
    }
    return p;
}

pair<int, int> Rec(int row = r, int col = c, int p = role)
{
    pair<int, int> win = make_pair(0, 0);

    bool pp = 1, en = 1;
    for (int i = 1; i <= n; ++ i)
    {
        if (pp == 0 and en == 0) break;

        if (p == 0)
        {
            pair<int, int> ans;
            if (col + i > n or mat[row][col + i] == 1) pp = 0;
            if (pp)
            {
                for (int j = col + 1; j <= col + i; ++ j)
                {
                    mat[row][j] = 1;
                }
                ans = Rec(row, col + i, p ^ 1);
                for (int j = col + 1; j <= col + i; ++ j)
                {
                    mat[row][j] = 0;
                }
                if (ans.fi == 0 and ans.se == 0)
                {
                    win.fi = row;
                    win.se = col + i;
                    return win;
                }
            }
            if (col - i < 1 or mat[row][col - i] == 1) en = 0;
            if (en)
            {
                for (int j = col - 1; j >= col - i; -- j)
                {
                    mat[row][j] = 1;
                }
                ans = Rec(row, col - i, p ^ 1);
                for (int j = col - 1; j >= col - i; -- j)
                {
                    mat[row][j] = 0;
                }
                if (ans.fi == 0 and ans.se == 0)
                {
                    win.fi = row;
                    win.se = col - i;
                    return win;
                }
            }
        }
        else
        {
            pair<int, int> ans;
            if (row + i > n or mat[row + i][col] == 1) pp = 0;
            if (pp)
            {
                for (int j = row + 1; j <= row + i; ++ j)
                {
                    mat[j][col] = 1;
                }
                ans = Rec(row + i, col, p ^ 1);
                for (int j = row + 1; j <= row + i; ++ j)
                {
                    mat[j][col] = 0;
                }
                if (ans.fi == 0 and ans.se == 0)
                {
                    win.fi = row + i;
                    win.se = col;
                    return win;
                }
            }
            if (row - i < 1 or mat[row - i][col] == 1) en = 0;
            if (en)
            {
                for (int j = row - 1; j >= row - i; -- j)
                {
                    mat[j][col] = 1;
                }
                ans = Rec(row - i, col, p ^ 1);
                for (int j = row - 1; j >= row - i; -- j)
                {
                    mat[j][col] = 1;
                }
                if (ans.fi == 0 and ans.se == 0)
                {
                    win.fi = row - i;
                    win.se = col;
                    return win;
                }
            }
        }
    }

    return win;
}

void play(int &R, int &C)
{
    xbgame(n, r, c);
    if (start)
    {
        start = false;
        mat[r][c] = 1;

        if ((r == 1 or r == n) and (c == 1 or c == n))
        {
            s2 = true;
            pm = makeMove(make_pair(r, c));
            R = pm.fi; C = pm.se;
            return;
        }
        else
        {
            s1 = true;
            mat[r][c] = 1;
            pm = Rec();
            if (pm.fi == 0 and pm.se == 0) role = 1;
            R = pm.fi;
            C = pm.se;
            return;
        }
    }
    else if (s2)
    {
        int dir;
        if (pm.fi < r) dir = +1;
        if (pm.fi > r) dir = -1;

        if (dir == +1) while (pm.fi + dir <= r)
        {
            pm.fi += dir;
            mat[pm.fi][pm.se] = 1;
        }
        if (dir == -1) while (pm.fi + dir >= r)
        {
            pm.fi += dir;
            mat[pm.fi][pm.se] = 1;
        }

        pm = makeMove(pm);
        R = pm.fi; C = pm.se;
        return;
    }
    else
    {
        int dir;
        if (pm.fi < r) dir = +1;
        if (pm.fi > r) dir = -1;

        if (role == 0)
        {
            if (pm.fi < r) dir = +1;
            if (pm.fi > r) dir = -1;
            if (dir == +1) while (pm.fi + dir <= r)
            {
                pm.fi += dir;
                mat[pm.fi][pm.se] = 1;
            }
            if (dir == -1) while (pm.fi + dir >= r)
            {
                pm.fi += dir;
                mat[pm.fi][pm.se] = 1;
            }
        }
        else
        {
            if (pm.se < c) dir = +1;
            if (pm.se > c) dir = -1;
            if (dir == +1) while (pm.se + dir <= c)
            {
                pm.se += dir;
                mat[pm.fi][pm.se] = 1;
            }
            if (dir == -1) while (pm.se + dir >= c)
            {
                pm.se += dir;
                mat[pm.fi][pm.se] = 1;
            }
        }

        pm = Rec(pm.fi, pm.se);
        R = pm.fi; C = pm.se;
        return;
    }
}

/*
int main()
{
    while (true)
    {
        int rr, cc;
        play(rr, cc);
        cout << "my move: " << rr << ' ' << cc << endl;
    }
}
*/
