#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

const int MAXN = 128;

int n, m, q;
vector<int> g[MAXN];
int cap[MAXN][MAXN], use[MAXN][MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        cap[u][v] = cap[v][u] = 1;
    }

    for (int i = 1; i <= n; ++ i)
    {
        random_shuffle(g[i].begin(), g[i].end());
    }
}

bool found = true;
int p[MAXN];

void DFS(int u = 1)
{
    if (found == true) return;
    if (u == n)
    {
        found = true;
        return;
    }

    for (int v : g[u])
    {
        if (p[v] == 0 and use[u][v] == 0 and cap[u][v] != 0)
        {
            p[v] = u;
            DFS(v);
            if (found == true) break;
            p[v] = 0;
        }
    }
}

void BFS()
{
    queue<int> q;
    q.push(1);

    while (!q.empty())
    {
        int u = q.front();
        q.pop();

        if (u == n)
        {
            found = true;
            break;
        }

        for (int v : g[u])
        {
            if (p[v] == 0 and use[u][v] == 0 and cap[u][v] != 0)
            {
                p[v] = u;
                q.push(v);
                if (found == true) break;
                //p[v] = 0;
            }
        }
    }
}

void MarkFlow()
{
    int u, v = n;
    while (v != 1)
    {
        u = p[v];
        if (cap[u][v] == +1)
        {
            use[u][v] = 1;
            cap[v][u] = -1;
        }
        if (cap[u][v] == -1)
        {
            use[u][v] = -1;
        }
        v = u;
       // cout << v << endl;
    }
}

int main()
{
    Init();

    int max_flow = 0;
    p[1] = -1;

    while (true)
    {
        found = false;
       // cout << "start bfs" << endl;
        BFS();
       // cout << "stop bfs" << endl;
        if (found == false) break;
        else max_flow++;

        MarkFlow();
        for (int i = 2; i <= 100; ++ i)
        {
            p[i] = 0;
        }
       // cout << max_flow << endl;
    }

    cout << max_flow << endl;

    cin >> q;
    return q;
}

/*
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
*/
