#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

const int MAXN = 128;

struct edge
{
    int adj, cap, use, rev;
    edge(){}
    edge(int adj, int cap, int use, int rev)
    {
        this -> adj = adj;
        this -> cap = cap;
        this -> use = use;
        this -> rev = rev;
    }
};

int n, m, q;
vector<edge> g[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v, 1, 0, g[v].size() - 0);
        g[v].emplace_back(u, 1, 0, g[u].size() - 1);
    }
}

bool found = true;
int p[MAXN][2];

void DFS(int u = 1)
{
    if (found == true) return;
    if (u == n)
    {
        found = true;
        return;
    }

    for (int i = 0; i < g[u].size(); ++ i)
    {
        if (p[g[u][i].adj][0] == 0 and g[u][i].use == 0)
        {
            p[g[u][i].adj][0] = u;
            p[g[u][i].adj][1] = i;
            DFS(g[u][i].adj);
        }
    }
}

void BFS()
{
    queue<int> q;
    q.push(1);

    while (!q.empty())
    {
        int u = q.front();
        q.pop();

        if (u == n)
        {
            found = true;
            break;
        }

        for (int i = 0; i < g[u].size(); ++ i)
        {
            if (p[g[u][i].adj][0] == 0 and g[u][i].use == 0)
            {
                p[g[u][i].adj][0] = u;
                p[g[u][i].adj][1] = i;
                q.push(g[u][i].adj);
            }
        }
    }
}

void MarkFlow()
{
    int u, v = n, i;
    while (v != 1)
    {
        u = p[v][0];
        i = p[v][1];
        if (g[u][i].cap == +1)
        {
            g[u][i].use = 1;
            g[v][g[u][i].rev].cap = -1;
        }
        if (g[u][i].cap == -1)
        {
            g[u][i].use = -1;
        }
        v = u;
    }
}

int main()
{
    Init();

    int max_flow = 0;
    p[1][0] = -1;

    while (true)
    {
        found = false;
        BFS();
        if (found == false) break;
        else max_flow++;

        MarkFlow();
        for (int i = 2; i <= 100; ++ i)
        {
            p[i][0] = p[i][1] = 0;
        }
    }

    cout << max_flow << endl;

    cin >> q;

    for (int i = 1; i <= q; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v, 1, 0, g[v].size() - 0);
        g[v].emplace_back(u, 1, 0, g[u].size() - 1);
        while (true)
        {
            found = false;
            for (int i = 2; i <= 100; ++ i)
            {
                p[i][0] = p[i][1] = 0;
            }
            BFS();
            if (found == false) break;
            else max_flow++;

            MarkFlow();
        }
        cout << max_flow << endl;
    }

    return 0;
}

/*
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
*/
