#include <cstdio>
#include <algorithm>
using namespace std;

#define MaxNumberOfVertices 100

struct Graph
{
    int numberOfVertices, numberOfEdges;
    int areConnected[MaxNumberOfVertices][MaxNumberOfVertices]; // 0 if not connected, 1 if connected and free, 2 if connected and taken
};

Graph ReadGraph()
{
    Graph graph;

    scanf("%d%d", &graph.numberOfVertices, &graph.numberOfEdges);

    for (int i = 0; i < graph.numberOfVertices; i++)
    {
        for (int j = 0; j < graph.numberOfVertices; j++)
        {
            graph.areConnected[i][j] = 0;
            graph.areConnected[j][i] = 0;
        }
    }
    int a, b;
    for (int i = 0; i < graph.numberOfEdges; i++)
    {
        scanf("%d%d", &a, &b);
        a--;
        b--;
        graph.areConnected[a][b] = 1;
        graph.areConnected[b][a] = 1;
    }

    return graph;
}

int MaxNumberOfUncommonPaths(Graph graph)
{
    int numberOfEdgesFrom1 = 0;
    for (int i = 0; i < graph.numberOfVertices; i++)
    {
        if (graph.areConnected[0][i] == 1)
        {
            numberOfEdgesFrom1++;
        }
    }

    int numberOfEdgesFromN = 0;
    for (int i = 0; i < graph.numberOfVertices; i++)
    {
        if (graph.areConnected[graph.numberOfVertices - 1][i] == 1)
        {
            numberOfEdgesFromN++;
        }
    }

    return min(numberOfEdgesFrom1, numberOfEdgesFromN);
}

int main()
{
    Graph graph = ReadGraph();

    int maxNumberOfUncommonPaths = MaxNumberOfUncommonPaths(graph);
    printf("%d\n", maxNumberOfUncommonPaths);

    int numberOfQueries;
    scanf("%d", &numberOfQueries);
    int a, b;
    for (int eachQuery = 0; eachQuery < numberOfQueries; eachQuery++)
    {
        scanf("%d%d", &a, &b);
        a--;
        b--;
        graph.areConnected[a][b] = 1;
        graph.areConnected[b][a] = 1;
        maxNumberOfUncommonPaths = MaxNumberOfUncommonPaths(graph);
        printf("%d\n", maxNumberOfUncommonPaths);
    }

    return 0;
}
