#include <cstdio>
using namespace std;

#define MaxPermLen 1000

int permLen, groupLen;
int seenPerms[MaxPermLen][MaxPermLen], numberOfSeenPerms;

bool AreTheSame(int perm1[], int perm2[])
{
    for (int i = 0; i < permLen; i++)
    {
        if (perm1[i] != perm2[i])
        {
            return false;
        }
    }

    return true;
}

void SwitchOperation(int perm[], int firstGroupBegin)
{
    int t;

    for (int i = 0; i < groupLen; i++)
    {
        t = perm[firstGroupBegin + i];
        perm[firstGroupBegin + i] = perm[firstGroupBegin + groupLen + i];
        perm[firstGroupBegin + groupLen + i] = t;
    }
}

void MarkAsSeen(int perm[])
{
    numberOfSeenPerms++;
    for (int i = 0; i < permLen; i++)
    {
        seenPerms[numberOfSeenPerms - 1][i] = perm[i];
    }
}

bool IsSeen(int perm[])
{
    for (int i = 0; i < numberOfSeenPerms; i++)
    {
        bool found = true;
        for (int j = 0; j < permLen; j++)
        {
            if (perm[j] != seenPerms[i][j])
            {
                found = false;
                break;
            }
        }

        if (found)
        {
            return true;
        }
    }

    return false;
}

bool Belongs(int perm1[], int perm2[])
{
    if (AreTheSame(perm1, perm2))
    {
        return true;
    }

    MarkAsSeen(perm1);
    MarkAsSeen(perm2);
    for (int firstGroupBegin = 0; firstGroupBegin + 2 * groupLen - 1 <= permLen; firstGroupBegin++)
    {
        SwitchOperation(perm1, firstGroupBegin);
        if (AreTheSame(perm1, perm2))
        {
            return true;
        }
        if (!IsSeen(perm1))
        {
            if (Belongs(perm1, perm2))
            {
                return true;
            }
        }
        SwitchOperation(perm1, firstGroupBegin);
    }

    return false;
}

int main()
{
    numberOfSeenPerms = 0;

    scanf("%d%d", &permLen, &groupLen);

    int perm1[MaxPermLen], perm2[MaxPermLen];
    for (int i = 0; i < permLen; i++)
    {
        scanf("%d", &perm1[i]);
    }
    for (int i = 0; i < permLen; i++)
    {
        scanf("%d", &perm2[i]);
    }

    if (Belongs(perm1, perm2))
    {
        printf("1\n");
    }
    else
    {
        printf("0\n");
    }

    return 0;
}
