#include <bits/stdc++.h>
#define endl '\n'

#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse4")

using namespace std;
template<class T, class T2> inline int chkmax(T &x, const T2 &y)
{
    return x < y ? x = y, 1 : 0;
}
template<class T, class T2> inline int chkmin(T &x, const T2 &y)
{
    return x > y ? x = y, 1 : 0;
}
const int MAXN = (1 << 18);

struct edge
{
    int flow, cap;
    int idx, rev, to;
    edge()
    {
        flow = 0;
        cap = 0;
        rev = 0;
        idx = 0;
        to = 0;
    }
    edge(int _to, int _rev, int _flow, int _cap, int _idx)
    {
        to = _to;
        rev = _rev;
        flow = _flow;
        cap = _cap;
        idx = _idx;
    }
};


struct max_flow
{
    vector<edge> G[MAXN];
    int n, dist[MAXN], po[MAXN];

    bool bfs(int s, int t)
    {
        dist[s] = -1, po[s] = 0;
        dist[t] = -1, po[t] = 0;
        for(int v = 0; v <= n; v++)
            dist[v] = -1, po[v] = 0;

        queue<int> Q;
        Q.push(s);
        dist[s] = 0;

        while(!Q.empty())
        {
            int u = Q.front();
            Q.pop();

            for(edge e: G[u])
                if(dist[e.to] == -1 && e.flow < e.cap)
                {
                    dist[e.to] = dist[u] + 1;
                    Q.push(e.to);
                }
        }

        return dist[t] != -1;
    }

    int dfs(int u, int t, int fl = (int)1e9)
    {
        if(u == t)
            return fl;

        for(; po[u] < G[u].size(); po[u]++)
        {
            auto &e = G[u][po[u]];
            if(dist[e.to] == dist[u] + 1 && e.flow < e.cap)
            {
                int f = dfs(e.to, t, min(fl, e.cap - e.flow));

                e.flow += f;
                G[e.to][e.rev].flow -= f;

                if(f > 0)
                    return f;
            }
        }

        return 0;
    }

    int id[1 << 7][1 << 7];

    void init(int _n)
    {
        memset(id, -1, sizeof(id));
        n = _n;
        for(int i = 0; i <= n; i++)
            G[i].clear();
    }

    void add_edge(int u, int v, int w, int idx = -1)
    {
        if(id[u][v] == -1)
            G[u].push_back(edge(v, G[v].size(), 0, w, -1)), id[u][v] = G[u].size() - 1;
        else G[u][id[u][v]].cap += w;

        if(id[v][u] == -1)
            G[v].push_back(edge(u, G[u].size() - 1, 0, w, -1)), id[v][u] = G[v].size() - 1;
        else G[v][id[v][u]].cap += w;
    }

    int flow(int s, int t)
    {
        int ret = 0, to_add;
        while(bfs(s, t))
            while((to_add = dfs(s, t)) > 0)
            {
                ret += to_add;
                // cout  << "here" << endl;
            }

        return ret;
    }
};

int n, m, q;

void read()
{
    cin >> n >> m;
}

max_flow mf;


void solve()
{
    mf.init(n + 42);
    while(m--)
    {
        int u, v;
        cin >> u >> v;
        mf.add_edge(u, v, 1);
    }

    int answer = mf.flow(1, n);
    cout << answer << endl;

    cin >> q;
    while(q--)
    {
        int u, v;
        cin >> u >> v;

        mf.add_edge(u, v, 1);

        answer += mf.flow(1, n);

        cout << answer << endl;
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

