#include <bits/stdc++.h>
#define endl '\n'

//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")

using namespace std;
template<class T, class T2> inline int chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline int chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

mt19937 mt(17);

struct node
{
	int sz, prior, value;
	node *l, *r, *par;
	node() { value = 0; sz = 0; prior = 0; par = nullptr; l = nullptr; r = nullptr; }
	node(int v) { value = v; sz = 1; prior = mt(); par = nullptr; l = nullptr; r = nullptr; }
};

using pnode = node*;

int size(pnode v) { return v ? v->sz : 0; }
void update_size(pnode &v) { if(v) v->sz = size(v->l) + size(v->r) + 1; }

void update_pars(pnode &t)
{
    if(!t) return;

    if(t->l) t->l->par = t;
    if(t->r) t->r->par = t;
}

void merge(pnode &t, pnode l, pnode r)
{
	if(!l) { t = r; if(t) t->par = nullptr; return; }
	if(!r) { t = l; if(r) t->par = nullptr; return; }

	if(l->prior > r->prior)
		merge(l->r, l->r, r), t = l;
	else
		merge(r->l, l, r->l), t = r;

    t->par = nullptr;
	update_size(t);
	update_pars(t);
}

void split(pnode t, pnode &l, pnode &r, int k, int add = 0)
{
	if(!t) { l = nullptr; r = nullptr; return; }

	int idx = add + size(t->l);
	if(idx <= k)
		split(t->r, t->r, r, k, idx + 1), l = t;
	else
		split(t->l, l, t->l, k, add), r = t;

    if(l) l->par = nullptr, update_pars(l);
    if(r) r->par = nullptr, update_pars(r);
	update_size(t);
    update_pars(t);
}

int get_pos(pnode it)
{
    pnode tmp = it;

    int ret = size(it->l);
    while(tmp)
    {
        if(tmp->par && tmp->par->r == tmp) ret += size(tmp->par->l) + 1;
        tmp = tmp->par;
    }

    return ret;
}

int n, k;
int p[MAXN], q[MAXN], encode[MAXN];
vector<int> gq[MAXN], gp[MAXN];
int actual[MAXN];

void read()
{
    cin >> n >> k;
    for(int i = 0; i < n; i++)
    {
        cin >> p[i];
        gp[i % k].push_back(p[i]);
    }

    for(int i = 0; i < n; i++)
    {
        cin >> q[i];
        gq[i % k].push_back(q[i]);
        encode[q[i]] = i;
    }
}

pnode root = nullptr;
pnode link[MAXN];

int id = 0;

void dfs(pnode t)
{
    if(!t) return;
    dfs(t->l);
    actual[id++] = t->value;
    dfs(t->r);
}

void build_pars(pnode t)
{
    if(!t) return;
    build_pars(t->l);
    build_pars(t->r);
    update_pars(t);
}

bool try_solve(int iter)
{
iter++;

    root = nullptr;
    id = 0;
    for(int i = 0; i < n; i++) actual[i] = -1;

    for(int i = 0; i < n; i++)
    {
        link[p[i]] = new node(p[i]);
        merge(root, root, link[p[i]]);
    }

    //if(iter != 0)
    /*for(int entr = 0; entr < 50; entr++)
    {
        int pos = mt() % (n - 2 * k + 1);
        pnode l = nullptr, mid = nullptr, r = nullptr, h = nullptr;

        split(root, l, mid, pos - 1);
        split(mid, mid, r, 2 * k - 1);
        split(mid, mid, h, k - 1);
        merge(mid, h, mid);
        merge(root, l, mid);
        merge(root, root, r);
    }*/

    for(int i = 0; i < n - 2 * k + 1; i++)
    {
        int pos = get_pos(link[i]);

        if(pos == 0)
        {
            pnode dummy = nullptr;
            split(root, dummy, root, 0);
            actual[id++] = i;
            continue;
        }

        if(pos + k - 1 >= size(root))
        {
            int st = size(root) - k, op = size(root);

            pnode l = nullptr, r = nullptr, mid = nullptr, dummy = nullptr;
            split(root, l, r, st - 1);
            split(r, mid, r, k - 1);
            split(l, dummy, l, op % k - 1);

            merge(l, mid, l);
            merge(root, l, r);
            merge(root, dummy, root);

            pos = get_pos(link[i]);
        }

        pnode l = nullptr, r = nullptr, mid = nullptr, dummy = nullptr;
        split(root, l, r, pos - 1);
        split(r, mid, r, k - 1);
        split(mid, dummy, mid, 0);
        merge(l, mid, l);
        merge(root, l, r);

        actual[id++] = i;
    }

    bool bad = 0;
    dfs(root);
    for(int i = 0; i < n; i++)
        if(actual[i] != i)
        {
            bad = 1;
            break;
        }

    if(!bad) { cout << 1 << endl; return 1; }
    return 0;
}

void solve()
{
    for(int i = 0; i < k; i++)
    {
        sort(gp[i].begin(), gp[i].end());
        sort(gq[i].begin(), gq[i].end());
        if(gp[i] != gq[i])
        {
            cout << 0 << endl;
            return;
        }
    }

    for(int i = 0; i < n; i++) p[i] = encode[p[i]];
    for(int i = 0; i < k; i++) for(auto &it: gq[i]) it = encode[it];

    int iter = 0;
    while(clock() < 0.15 * CLOCKS_PER_SEC)
    {
        if(try_solve(iter)) return;
        iter++;
    }

    cout << 0 << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}

